#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);\
    cin.tie(nullptr);
    
    // 1) ULAZ
    
    int t;  //da li pantu zanima redosled?
    cin >> t;
    
    int n;  //broj ljudi koji ce da vide blog
    int k;  //zeljena uvazenost
    cin >> n >> k;
    
    vector<int> a(n);
    
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    
    // 2) USLOVI
    
    if((a.size() - k) % 2 != 0) {
        cout << "NE" << '\n';
        return 0;
    }
    
    cout << "DA" << '\n';
    
    int M = (a.size()-k)/2;
    
    sort(a.begin(), a.end());
    
    reverse(a.begin(), a.begin() + M);
    
    for(int i : a) {
        cout << i << " ";
    }

    return 0;
}